<?php

// Check platform
//
if (atGetPlatform() == "php-nuke")
{
    // How to register an extra and the functions that it performs and when to perform them (at operation)
    //
    // $extra[extra name] = array ( 'at operation' => "extra function" );
    //
    $extra['autourls'] = array (
           'name' => 'AutoURLs',
           'description' => 'Short URLs implementation for AutoTheme',
           'version' => '1.7',
           'author' => 'Shawn McKenzie',
           'contact' => 'http://www.spidean.com',
           'themepostprocess' => 'at_autourls_rewrite',
           'atadmin' => 'at_admin_autourls'
    );
}

// Extra functions
//
function at_autourls_rewrite($display)
{
    $autourls = atAutoGetVar("autourls");
    $autourlsext = $autourls['extension'];
    
    if (!$autourlsext) {
        $autourlsext = "phtml";
    }
    $prefix = '|[\'\"]*';
    $suffix = '[\>\'\"]|';

    $search = array(    
        $prefix.'index.php'.$suffix,
        $prefix.'modules.php\?name=News&(?:amp;)?file=article&(?:amp;)?sid=(\d+)&(?:amp;)?mode=([^&]*)&(?:amp;)?order=(\d)&(?:amp;)?thold=([-\d]{1,2})'.$suffix,
        $prefix.'modules.php\?name=News&(?:amp;)?file=article&(?:amp;)?sid=(\d+)'.$suffix,
        $prefix.'modules.php\?name=([\w\d\.\:\_\/]+)'.$suffix,
        $prefix.'modules.php\?name=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)'.$suffix,
        $prefix.'modules.php\?name=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)'.$suffix,
        $prefix.'modules.php\?name=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)'.$suffix,
        $prefix.'modules.php\?name=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)'.$suffix,
        $prefix.'modules.php\?name=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)&(?:amp;)?mode=&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)'.$suffix,    
        $prefix.'modules.php\?name=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)'.$suffix,
        $prefix.'modules.php\?name=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)'.$suffix,
        $prefix.'modules.php\?name=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)&(?:amp;)?([\w\d\.\:\_\/]+)=([\w\d\.\:\_\/]+)'.$suffix,
        //remove sid
        '|-sid-[^\.]+\.'.$autourlsext.'|',
    );
    
    $replace = array(    
        '"index.'.$autourlsext.'"',
        '"Article$1.'.$autourlsext.'"',
        '"Article$1.'.$autourlsext.'"',    
        '"$1.'.$autourlsext.'"',
        '"$1-$2-$3.'.$autourlsext.'"',
        '"$1-$2-$3-$4-$5.'.$autourlsext.'"',
        '"$1-$2-$3-$4-$5-$6-$7.'.$autourlsext.'"',
        '"$1-$2-$3-$4-$5-$6-$7-$8-$9.'.$autourlsext.'"',
        '"$1-$2-$3-$4-$5-$8-$9.'.$autourlsext.'"',    
        '"$1-$2-$3-$4-$5-$6-$7-$8-$9-$10-$11.'.$autourlsext.'"',
        '"$1-$2-$3-$4-$5-$6-$7-$8-$9-$10-$11-$12-$13.'.$autourlsext.'"',
        '"$1-$2-$3-$4-$5-$6-$7-$8-$9-$10-$11-$12-$13-$14-$15.'.$autourlsext.'"',
        //remove sid
        '.'.$autourlsext,  
    );

    $display = preg_replace($search, $replace, $display);

    return $display;
}

function at_admin_autourls($autourls)
{
    extract($autourls);

    if (!$extension) {
        $extension = "phtml";
    }	
    $output = _AT_EXTENSION." .<input type=\"text\" name=\"extension\" value=\"$extension\">\n";
	
	return $output;
}

?>
